//************************************************************************
// Datei: display.c
// Hauptprogramm
// 
// Demoprogramm um Text und Grafik auf
// KS108 Grafik-LCD-Display anzuzeigen
// Display: Displaytech 64240A 128x64 Pixel
//
// Compiler WinAVR 3.3
//************************************************************************
// Prozessor: ATMega32
//************************************************************************

#include <avr/io.h>
#include <avr/interrupt.h>
//#include <avr/signal.h>
#include <stdlib.h>
#include <stdint.h>
#include <string.h>

#include "protos.h"

int main(void)
{
	uint8_t i=0, minuten=0, stunden=0;
	
 Init_Timer();

 InitDisplay();

//Beginn Endlosschleife DEMO MODE
 while(1)
  {
 	
    
    ClearScreen();
    UpdateDisplay(1);
 
		DrawRect(0, 0, 127, 63,1); //Doppelter Rahmen zeichnen
		DrawRect(1,1,125,61,1);

		UpdateDisplay(1);
		Delay1ms(1000);

		DrawLine(4,4,123,59,1);		// Diagonal
		DrawLine(123,4,4,59,1);

		UpdateDisplay(1);
		Delay1ms(300);
		
		Circle(63, 32, 25, 1);
		UpdateDisplay(1);
		Delay1ms(300);

		for ( i=0; i < 16; i++ ){

			Circle(63, 32, 4+i,1); // Test neue Funktion
				UpdateDisplay(0);

		}
		Delay1ms(500);
		for ( i=0; i < 16; i++ ){

			
			Circle(63,32,4+i,0);
				UpdateDisplay(0);
		}


		Circle(63,32,21,1);
		UpdateDisplay(1);
		Delay1ms(500);
		FillCircle(63,32,20,1);
		UpdateDisplay(1);
		Delay1ms(500);
		ClearScreen();

		ShowSoftFont(1,1);

		UpdateDisplay(0);
		Delay1ms(500);

		ScrollUp();		// Scroll one line up

		UpdateDisplay(0);
		Delay1ms(1000);
		ClearScreen();
		Circle(64,32,31,1);

		for (stunden = 0; stunden < 2; stunden++){

			for(minuten=0; minuten < 60; minuten++){
						paint_uhr(stunden,minuten,1);
						Delay1ms(100);
						UpdateDisplay(0);
			}
		}
		FillCircle(64,32,31,1);
		for (stunden = 3; stunden < 5; stunden++){

			for(minuten=0; minuten < 60; minuten++){
						paint_uhr(stunden,minuten,0);
						Delay1ms(100);
						UpdateDisplay(0);
			}
		}
			
		ClearScreen();		
		SetFont(2);
		LCDSoftText("Hercules...",1,1,1);
		LCDSoftText("Lucy Trixi",1,17,1);
		UpdateDisplay(1);
		Delay1ms(1000);

		SetFont(3);
		LCDSoftText("Hercules...",1,34,1);
		LCDSoftText("Lucy Trixi",1,51,1);
		UpdateDisplay(1);
		Delay1ms(1000);

		ClearScreen();
		SetFont(1);
		FillRect(1,1,127,63,1);
		LCDSoftTextV("Lucy Trixi",1,63,0);
		UpdateDisplay(0);
		Delay1ms(1000);

 
   } //Endlosschleife
}



